#include<bits/stdc++.h>
using namespace std;
int main()
{
	unsigned long long int n,q,pojela=0,i,j,dan,s=0;  // kupovina je ujutru, jede se u podne a odustajanje od jela uvece
	cin>>n>>q; 
	unsigned long long int dkk[n],pak[n],pit[q];  //dkk - dani kad su kupljeni keksovi , pak-koliko keksova kupljeno,
	
	for (i=0;i<n;i++)
	{cin>>dkk[i]>>pak[i];}
	
	for (i=0;i<q;i++)
	{cin>>pit[i];
	}

    unsigned long long int o,e,x=0;
	
	
	for(j=0;j<q;j++)
	{	
		o=0;e=0;
		for (i=dkk[0];i<=pit[x];i++)
		{
			if (e<n)
			{
				dan=dkk[e++];
			}
			if (i==dan)
			{
				s=s+pak[o];
				o++;
			}
			
			
			if(s>0)
			{
				pojela++;
				s--;
			}	
		}
	cout<<pojela<<endl;
	x++;
	}
}